/*
 * To setup..
 * (Optional) Make a new titanium app and just replace the app.js with this app.js
 * You need to create a user to login. 
 * Put that user's ID into the loginDefault() function where it says <USER ID GOES HERE>
 * Fill in the password and login for the user below
 * Make sure that tiapp.xml has the following block
 * <modules>
		<module platform="commonjs">ti.cloud</module>
		<module platform="android">ti.cloudpush</module>
    </modules>
 */

// Containing Window
var win = Titanium.UI.createWindow({
	title: 'Push Test',
	backgroundColor: '#fff'
});

/**
 * You must have a user created already to use this sample app!
 */
var login = ""; // Replace with an ACS user login
var password = ""; // Replace with an ACS user password


/*
 * Require Cloud regardless of platform
 */
var Cloud = require('ti.cloud');

/*
 * Setup CloudPush for android
 */
if(Ti.Platform.osname == "android"){
	var CloudPush = require('ti.cloudpush');
	CloudPush.addEventListener('callback', function(evt) {
					//alert(evt.payload);
	});
	
	CloudPush.addEventListener('trayClickLaunchedApp', function(evt) {
		//alert("callback" + JSON.stringify(evt));
	});

	CloudPush.addEventListener('trayClickFocusedApp', function(evt) {
		//alert('Tray Click Focused App (app was already running)' + JSON.stringify(evt));
	});
}

/*
 * This function is called when the 'button' label is clicked
 */
function pushIT(){
	//Android: Get Device Token and call loginDefault();
	if(Ti.Platform.osname == "android"){
		CloudPush.enabled = true;
		CloudPush.retrieveDeviceToken({
			success: function deviceTokenSuccess(e) {
				console.log("DeviceToken "+e.deviceToken)
				loginDefault(e.deviceToken);
			 },
			error: function deviceTokenError(e) {
				alert('Failed to register for push! ' + e.error);
			}
		});

	//iOS: Get device token if it hasn't been rerived. Otherwise call loginDefault()
	}else{
		//if we have never registered push
		if(!Ti.Network.remoteNotificationsEnabled){
			Ti.Network.registerForPushNotifications({
				// Specifies which notifications to receive
				types: [
				Ti.Network.NOTIFICATION_TYPE_BADGE,
				Ti.Network.NOTIFICATION_TYPE_ALERT,
				Ti.Network.NOTIFICATION_TYPE_SOUND
				],
				success: function(e){
					loginDefault(e.deviceToken);
				},
				error: function(e){
					alert(e.error);
				},
				callback: function(e) {
					alert('Received push: ' + JSON.stringify(e));
				}
			});
		//if we already have registered push
		}else{
			button.text += "\n"+ ('Push Already Enabled');
			loginDefault(Ti.Network.remoteDeviceUUID);
		}
	}
}


/*
 * 1. Log user in
 * 2. Subscribe to Message channel
 * 3. Leave App
 * 4. Sends a push notification to a user (I WAS using myself. You'll need to populate that field). 
 */
function loginDefault(token) {

	Cloud.Users.login({
		login: login,
	password: password
	}, function(e) {
		if (e.success) {
			defaultSubscribe(token);
			Ti.Platform.openURL("http://www.google.com");
			//Send a push in 4 seconds
			setTimeout(function() {
				Cloud.PushNotifications.notify({
					channel: 'message',
					to_ids:"<USER ID GOES HERE>",
					payload:"This is a push test!"
				}, function(e) {
					if (e.success) {
						//button.text += "\n"+ ('Success notify');
					} else {
						//button.text += "\n"+ ('Error:\n' + ((e.error && e.message) || JSON.stringify(e)));
					}
				});
			}, 4000);
		} else {
			button.text += "\n"+ ('Login Error:\\n' + ((e.error && e.message) || JSON.stringify(e)));
		}
	});

}

/*
 * Subscribe the device to the 'message' channel with the retrieved token. 
 */
function defaultSubscribe(token) {
	if(Ti.Platform.osname != "android"){
		var type = null;
	}else{
		type = "gcm"
	}
	Cloud.PushNotifications.subscribe({
		channel: 'message',
		device_token: token,
		type: type
	}, function(e) {
		if (e.success) {
			button.text += "\n"+ ("subscribed");
			if(Ti.Platform.osname == "android"){
				
			}
		} else {
			alert('Error:' + ((e.error && e.message) || JSON.stringify(e)));
		}
	});
}
var button = Ti.UI.createLabel({
	text:'push stuff',
	width:Ti.UI.FILL,
	textAlign:'center',
	height:Ti.UI.SIZE
});
button.addEventListener('click', function(){
	pushIT();
});
win.add(button);
win.open();
